//设置cookie、
$.setCookie = function(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
        var expires = "expires=" + d.toGMTString();
        document.cookie = cname + "=" + cvalue + "; " + expires;
    }
    //获取token
$.getCookie = function(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i].trim();
        if (c.indexOf(name) == 0) return c.substring(name.length, c.length);
    }
    return "";
}

(function() {
    //首先备份下jquery的ajax方法
    var _ajax = $.ajax;
    //重写jquery的ajax方法
    $.ajaxToken = function(opt) {
        //备份opt中error和success方法
        var fn = {
            error: function(XMLHttpRequest, textStatus, errorThrown) {},
            success: function(data, textStatus) {}
        }
        if (opt.error) {
            fn.error = opt.error;
        }
        if (opt.success) {
            fn.success = opt.success;
        }
        //扩展增强处理
        var _opt = $.extend(opt, {
            error: function(XMLHttpRequest, textStatus, errorThrown) {
                if (XMLHttpRequest.status == '401') { //token 失效
                    var flushTokenStr = localStorage.getItem('flushToken');
                    flushToken(flushTokenStr, function() {
                        $.ajaxToken(opt);
                    });
                } else {
                    fn.error(XMLHttpRequest, textStatus, errorThrown);
                }
            },
            success: function(data, textStatus) {
                //成功回调方法增强处理
                fn.success(data, textStatus);
            },
            beforeSend: function(xhr) {
                //提交前回调方法
                var token = localStorage.getItem('token');
                xhr.setRequestHeader('Authorization', 'Bearer ' + token);
            },
            complete: function(XHR, TS) {
                //请求完成后回调函数 (请求成功或失败之后均调用)。
            }
        });
        return _ajax(_opt);
    };
}())


// //获取测试token
// function testToken() {
//     $.ajax({
//         url: 'http://192.168.0.109:5000/api/users/461d7aa1-2f8f-4c7d-a6df-672a4f0eaa59/token',
//         dataType: 'jsonp',
//         success: function (res) {
//             alert(res.data);
//             var tokenInfo = JSON.parse(res.data);
//             //设置新的token
//             setToken(tokenInfo.access_token, tokenInfo.refresh_token);
//         }
//     });
// }


//获取token
function getToken() {
    return localStorage.getItem('token');
}

//设置token
function setToken(token, flushToken) {
    localStorage.setItem('token', token);
    localStorage.setItem('flushToken', flushToken);
}

//刷新token
function flushToken(refreshToken, callback) {
    refreshToken = refreshToken || localStorage.getItem('flushToken');
    $.ajax({
        url: '/api/users/token',
        type: 'put',
        data: {"refreshToken": refreshToken},
        dataType: "jsonp",
        jsonp: "callback",
        success: function (res) {
            if (res.code == 200) {
                var tokenInfo = JSON.parse(res.data);
                if (tokenInfo) {
                    setToken(tokenInfo.access_token, tokenInfo.refresh_token);
                    if (callback) callback();
                } else {
                    api.alert({
                        title: '提醒',
                        msg: '长时间未操作，请重新考试~',
                    }, function(ret, err){
                        api.closeWin();
                    });

                }
            }
        }
    });
}


//获取Token码
function GetTokenCode() {
    $.ajax({
        url: basePath + "/Home/GetTokenCode",
        type: "get",
        dataType: "jsonp",
        jsonp: "callback",
        async: false,
        timeout: 20000,
        success: function(mes) {
            if (mes.success) {
                var jsonData = JSON.parse(mes.DataObj.data);
                access_token = jsonData.access_token;
                refresh_token = jsonData.refresh_token;
                setToken(access_token, refresh_token)
            } else {
                alert('获取token码失败~');
            }
        }
    });
}
